<?php

/**
 * cgmv_inf_orden_pagos actions.
 *
 * @package    radicacionVirtualCuentas
 * @subpackage cgmv_inf_orden_pagos
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class cgmv_inf_orden_pagosActions extends sfActions {

    /**
     * Executes list action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Paginacion
         */
        if (isset($request['_startRow'])) {
            $rowStart = $request['_startRow'];
        } else {
            $rowStart = 0;
        }

        if (isset($request['_endRow'])) {
            $rowEnd = $request['_endRow'];
        } else {
            $rowEnd = 75;
        }

        //ordenar consulta
        if (isset($request['_sortBy'])) {
            $sortBy = " Order by " . $request['_sortBy'];
        } else {
            $sortBy = ' Order by fecha_radicado, radicado';
        }
        $sortBy = ' ';

        /*
         * Manejo de errores
         */
        try {
            /*
             * Variables obligatorias
             */
            $fecha_ini = $request['fecha_ini'];
            $fecha_fin = $request['fecha_fin'];
            $fecha_ini_text = $fecha_ini;
            $fecha_fin_text = $fecha_fin;


            /*
             * Variables opcionales
             */
            //id_contratista
            if (isset($request['id_contratista'])) {
                $whereIdContratista = " AND tab0.id_contratista = " . $request['id_contratista'];
            } else {
                $whereIdContratista = ' ';
            }
            //id_contrato
            if (isset($request['id_contrato'])) {
                $whereIdContrato = " AND tab0.id_contrato = " . $request['id_contrato'];
            } else {
                $whereIdContrato = ' ';
            }
            //id_numero_pago
            if (isset($request['id_numero_pago'])) {
                $whereIdNumeroPago = " AND tab0.id_numero_pago = " . $request['id_numero_pago'];
            } else {
                $whereIdNumeroPago = ' ';
            }
            //usuario_asignado
            if (isset($request['usuario_asignado'])) {
                $whereUsuarioAsignado = " AND tab0.usuario_asignado = '" . $request['usuario_asignado'] . "'";
            } else {
                $whereUsuarioAsignado = ' ';
            }
            //Recurso: 0-ANM 1-SGR
            $recurso = '';
            if (isset($request['recurso'])) {
                if ($request['recurso'] == 1) {
                    $recurso = ' SGR';
                    $whereTipoRecurso = " AND tab0.tipo_recurso = 1 ";
                } elseif ($request['recurso'] == 0 && $request['recurso'] != 'false') {
                    $recurso = ' PGN';
                    $whereTipoRecurso = " AND tab0.tipo_recurso = 0 ";
                } else {
                    $whereTipoRecurso = " ";
                }
            } else {
                $whereTipoRecurso = "";
            }

            $filtro_clase_presup = "";
            if (isset($request['clasepresup'])) {
                if ($request['clasepresup'] == 8) {
                    $clasepresup = 8;
                } elseif ($request['clasepresup'] == 9) {
                    $clasepresup = 9;
                } else {
                    $clasepresup = 0;
                }

                if ($clasepresup != 0) {
                    /**
                     * Filtro por clase presupuestal 8-funcionamiento o 9-inversion - 20220405::LAVILA
                     */
                    $filtro_clase_presup = <<<EOD
and tab0.id_formato_pago in (

    select
    forrp.id_formato_pago
    
    from rvc_formato_proy_rp forrp
    
    join rvc_formato_pago forpag
    on forrp.id_formato_pago = forpag.id_formato_pago
    
    left join pr_rubro_pgnsgr_v rub
    on rub.id_rubro = forrp.id_rubro
    and rub.sgr = forrp.is_rp_sgr
    
    where
    rub.id_clase_presup = $clasepresup                            
    and forrp.valor != 0
    and forpag.estado = 1
    and forpag.cargasiif = 1
    and trunc(forpag.fecha_radicado) between to_date('$fecha_ini_text','yyyy-mm-dd') and to_date('$fecha_fin_text','yyyy-mm-dd')

)
EOD;
                }
            }


            //sentencia sql
            $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            //ejecuta y obtiene el resultado del sql
            CN_TABLE::executeSQL($sql);

            /**
             * Consulta de pagos por fecha y estado aprobado
             * Recurso: 0-ANM 1-SGR
             * Se deben cargar los radicados en estado OBLIGADO.
             */
            $consulta_sql = <<<EOD
select
rownum as consecutivo,
case when tab0.tipo_recurso = 0 then dat.CODIGO_SIIF else dat.CODIGO_SPGR end as PCIConexion,
trunc(sysdate) as fecha,
case when tab0.tipo_recurso = 0 then tab0.doc_soporte_oblpgn else tab0.doc_soporte_oblsgr end as obligacion,

case when tab0.tipo_recurso = 0 then dat.CODIGO_SIIF else dat.CODIGO_SPGR end as pciunidad,
tab0.numero_pac as pac,
case when tab0.tipo_recurso = 0 then tab0.fecha_soporte_oblpgn else tab0.fecha_soporte_oblsgr end as fecha_obligacion,

tab0.valor_bruto as valor_actual,		
'B' as tipo_beneficiario,
'AC' as medio_pago,
dat.CODIGO_DTN as tesoreria_dtn,
'03' as tipo_documento,
tab0.num_doc as numero_doc,
tab0.num_cuenta as cuenta,
tab0.tipo_cuenta as tipo_cuenta,
DIAS_HABILES(trunc(sysdate),2) as fecha_pago,
36 as doc_soporte,
tab0.num_contrato as doc_compromiso,
tab0.fecha_contrato as fecha_doc_compromiso,
5 as cargo_fijo,
tab0.razon_social as contratista,
'CONTRATISTA' as cargo,
'RVC '|| tab0.numero_radicado ||' CTO '|| tab0.num_contrato || ' ' || tab0.pago_text || ' PAGO' || '-PERIODO '|| trim(upper(to_char(tab0.FECHA_INI_PAGO,'MONTH','nls_date_language=spanish'))) || '/' || to_char(tab0.FECHA_INI_PAGO,'YY') as texto,
'RVC '|| tab0.numero_radicado ||' CTO '|| tab0.num_contrato ||' P'|| tab0.id_numero_pago ||' P'|| to_char(tab0.FECHA_INI_PAGO,'MON')|| to_char(tab0.FECHA_INI_PAGO,'YY') || ' - RP '|| tab0.id_rp_proyrp  || ' ASIG. ' || upper(tab0.RAZON_SOC_USU_ASIGNA) as texto1,
                   
tab0.id_formato_pago,
tab0.id_anhos,
tab0.id_numero_pago,
tab0.num_contrato                    

from(

    select distinct
    proyrp.is_rp_sgr as tipo_recurso,
    proyrp.id_rp as id_rp_proyrp,
    proyrp.vigencia_rp,
    proyrp.is_rp_sgr,
    
    contra.num_doc,
    contra.razon_social,
    cont.fecha_contrato,
    contra.num_cuenta,
    contra.declarante_renta,
    cont.razon_soc_sup,
    contra.profesion,
    cont.num_contrato,
    nump.descripcion as pago_text,
    tc.nombre_corto as tipo_cuenta,
                    
    nvl(proyrp.valor,0) as valor_bruto,
    proyrp.numero_pac,
    
    adj.doc_soporte_oblpgn,
    adj.fecha_soporte_oblpgn,
    adj.doc_soporte_oblsgr,
    adj.fecha_soporte_oblsgr,
    
    forpag.*
    
    from rvc_formato_pago_v forpag
    
    left join rvc_contrato_v cont
    on forpag.id_contrato = cont.id_contrato
    
    left join rvc_contratista_v contra
    on forpag.id_contratista = contra.id_contratista
    
    left join ts_tc tc
    on tc.id = contra.tipo_cuenta
    
    left join rvc_numero_pago nump
    on nump.id_numero_pago = forpag.id_numero_pago
    
    left join(
    
        select
        fp.id_formato_pago,
        to_char(wm_concat(distinct fp.id_rp)) as id_rp,
        to_char(wm_concat(distinct fp.vigencia_rp)) as vigencia_rp,
        fp.is_rp_sgr,
        sum(fp.valor) as valor,
        min(pac.numero_pac) as numero_pac
        
        from rvc_formato_proy_rp fp
        
        left join pr_codif_presup rub
        on rub.id_rubro = fp.id_rubro
        
        left join pr_tipo_rec rec
        on rec.id = fp.id_tipo_rec
        
        left join rvc_posicion_catalogo_pac pac
        on pac.catalogo_gasto = rub.codigo_rubro
        and nvl(pac.id_agrup_rec,rec.id_agrup) = nvl(rec.id_agrup,0)
        
        where
        fp.valor != 0
        
        group by
        fp.id_formato_pago,
        /*fp.id_rp,
        fp.vigencia_rp,*/
        fp.is_rp_sgr
    
    )proyrp
    on proyrp.id_formato_pago = forpag.id_formato_pago
    
    left join(
        select
        adj.id_formato_pago,
        min(adj.doc_soporte) as doc_soporte_oblpgn,
        min(adj.fecha_soporte) as fecha_soporte_oblpgn,
        min(adj.doc_soporte) as doc_soporte_oblsgr,
        min(adj.fecha_soporte) as fecha_soporte_oblsgr
        
        from rvc_formato_pago_adj adj
        
        where
        upper(adj.nombre_adjunto) like '%OBLIGA%'
        
        group by
        adj.id_formato_pago
    )adj
    on adj.id_formato_pago = forpag.id_formato_pago
    
    where
    forpag.estado = 1
    and forpag.estado_general = 6
    and trunc(forpag.fecha_radicado) between to_date('$fecha_ini_text','yyyy-mm-dd') and to_date('$fecha_fin_text','yyyy-mm-dd')
    
    order by
    forpag.fecha_radicado,
    forpag.radicado

)tab0

left join datos_compania dat
on dat.id = 1

where
1 = 1
$whereIdContratista
$whereIdContrato
$whereIdNumeroPago
$whereTipoRecurso
$whereUsuarioAsignado 
$filtro_clase_presup                    
EOD;

            /*
             * Sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from (
                    
    $consulta_sql    
                    
)
EOD;


            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];


            //obtener el listado de recaudos
            $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (

    $consulta_sql

    $sortBy
          
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
            //ejecuta y obtiene el resultado del sql
            $resultado = CN_TABLE::executeSQL($sql);


            $this->totalRows = $total_record_count;
            $this->startRow = $rowStart;
            $this->endRow = $rowStart + count($resultado);
            $this->list_data = $resultado;
            $this->logMessage("[cgmv_inf_orden_pagos] Consulta exitosa.");
        } catch (Exception $e) {

            $this->status = 1;
            $this->totalRows = 0;
            $this->startRow = 0;
            $this->endRow = 0;
            $this->list_data = array();
            $this->logMessage("ERROR!!!");
            $this->logMessage($e->getMessage());
        }
    }

}
